#!/bin/bash
# Copyright 2008-2011 Matus Chochlik. Distributed under the Boost
# Software License, Version 1.0. (See accompanying file
# LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
# this script rebuilds the automatically generated
# Makefile rules for gnu make.
# It must be executed from the library's root directory
# containing the include/ src/ and devel/ source subdirs
# and the build system subdirectory.
#
# rebuild the c++ source/header dependency rules
echo "Header dependencies"
$(dirname $0)/make_hdr_deps.sh include src devel > build/make/Makefile.hdr_deps
#
# rebuild the devel/testing build rules
echo "Devel/Testing sources"
echo devel |
$(dirname $0)/make_single_srcs.sh include src devel > build/make/Makefile.devel_test
# rebuild the rules for building devel/testing localization files
echo "Localization for devel/testing sources"
$(dirname $0)/make_po_to_mo.sh devel > build/make/Makefile.devel_test_lc
#
source $(dirname $0)/_get_parts.sh
# rebuild the build rules for Mirror's and Lagoon's examples
for part in ${parts}
do
	echo "${part^?}'s examples"
	echo src/${part}/example |
	$(dirname $0)/make_single_srcs.sh include src > build/make/Makefile.${part}_example
done
#
# rebuild the rules for making the doxygen generated docs
echo "Doxygen docs"
for part in ${parts}
do $(dirname $0)/make_doxy_docs.sh ${part} include src > build/make/Makefile.doxygen.${part}
done
