#!/bin/bash
# Copyright 2008-2010 Matus Chochlik. Distributed under the Boost
# Software License, Version 1.0. (See accompanying file
# LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
# get the list of parts
source $(dirname $0)/_get_parts.sh
# just in case ...
make output_dir
# boostify the sources and headers
$(dirname $0)/_boostify_dir.sh \
$(for part in ${parts}; do echo include/${part} src/${part}/example; done)
#
# copy the license
cp LICENSE_1_0.txt out/boosted/LICENSE_1_0.txt
# copy everything from the boosted directory
cp -R boosted/* out/boosted/
#
# copy the Jamfile and its modules
mkdir -p out/boosted/build/bjam
#
translate_jamfile_sed="$(
for part in ${parts}
do echo "s|\<src/${part}|libs/${part}|;"
done
)"
#
for file in build/bjam/*
do sed "${translate_jamfile_sed}" < ${file} > out/boosted/${file}
done
